#ifndef LWIN_H
#define LWIN_H
#include <ldraw.h>

#define MAX_BUTTON   300
#define MAX_WINDOW   100
#define CLICK_DELAY   80
#define NUL_BELONG  9999

#define BMODE_NULL     0
#define BMODE_WORK     1
#define WMODE_NULL     0
#define WMODE_WORK     1
#define WMODE_ACTIVE   2
#define WTYPE_PASSIVE  0
#define WTYPE_INITIACT 1

#define WFORBID_HIGH   (1<<15)

#define cmNORMAL       0
#define cmEXIT         1
#define cmTMENU        2
#define cmSTART        3
#define cmDESTORY      4
#define cmNORMAL_CALL  5
#define cmOK           6

struct TBUTTON
{ short mode,index,belong_win;
  unsigned command, forbid;
  short x1,y1,x2,y2;
  char  *name, *bitmap;
};


extern void (*WinHandleEvent)(int Event);
extern TBUTTON *WinButtons;
extern TWin *WinWindows;
extern int WinEvent;

/* Functions */
char WinInit();
void WinRun();
int  WinCreateButton(TBUTTON *b);
int  WinCreateWindow(TWin *w);
void WinDelButton(TBUTTON *b);
void WinDelWindow(TWin *w);
void WinClearButton();
///////////////////////////////////////////////////////////
void WinMessageBox(char *title,char *string);
void WinMessageBox(short x1,short y1,short x2,short y2,char *title,char *string);
///////////////////////////////////////////////////////////
/* You can't use the functions below */
void Win_child_DrawB(TBUTTON *b,char mode);
void Win_child_DrawW(TWin *w);
void Win_child_Clear(TWin *w);
void Win_child_SendEvent(int index,int Event);
void Win_child_ForbidAll(int forbid);
void Win_UnForbidAll(int forbid);
int  Win_Button_Process();
int  Win_Window_Process();
#endif
